<template>
    <div>
        <h1>Todo List</h1>
        <ul>
            <li v-for="todo in filteredTodos" v-bind:key="todo.id">
                <input type="checkbox" v-bind:checked="todo.done" v-on:change="changeDone(todo,$event)">
                <span :class="{ done: todo.done }">{{ todo.name }}</span>
                <button v-on:click="removeTodo(todo,$event)">x</button>
            </li>
        </ul>
        <form v-on:submit.prevent="addTodo">
            <input type="text" v-model="newTodoValue">
            <button>Add todo</button>
        </form>

        <button v-on:click="hideCompleted = !hideCompleted">
            {{ hideCompleted ? 'Show all' : 'Hide completed' }}
        </button>

    </div>
</template>
<script>
let id = 0;
export default {
    name: "Todos",
    data() {
        return {
            todos: [{ id: id++, name: "clean house", done: true }, { id: id++, name: "study vue", done: false }],
            newTodoValue: null,
            hideCompleted: false
        }
    },
    methods: {
        addTodo(event) {
            let newTodo = {};
            newTodo.id = id++;
            newTodo.done = false;
            newTodo.name = this.newTodoValue;
            console.log("---newTodo=", newTodo);
            this.todos.push(newTodo)
        },
        removeTodo(todo2remove, event) {
            this.todos = this.todos.filter((todo) => {
                return (todo != todo2remove);
            });           
        },
        changeDone(todo, event) {
            console.log("----todo=", todo);
            console.log("-----event.target.checked=", event.target.checked);
            todo.done = event.target.checked;
        }
    },
    computed: {
        filteredTodos() {
            if (this.hideCompleted) {
                return this.todos.filter((todo) => {
                    return (todo.done == false)
                })
            } else {
                return this.todos;
            }
        }
    }
}
</script>

<style>
.done {
    text-decoration: line-through;
}
</style>